# -*- coding: utf-8 -*-
# Copyright (C) 2007-2008 www.stani.be
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/

import imp
import os
import sys
from Blender import Scene

class BlenderScript(object):

    def __init__(self):
        self.args = Arguments()
        self.args.parse_argv()

    def render(self):
        script = imp.load_source(self.args['script'], self.args['script_path'])
        script.set_up_render(self.args)

        scn = Scene.GetCurrent()
        ctx = scn.getRenderingContext()

        ctx.sFrame = 1
        ctx.eFrame = 1

        ctx.imageSizeX(int(self.args['render_width']))
        ctx.imageSizeY(int(self.args['render_height']))

        render_path = os.path.splitext(self.args['render_path'])[0]
        
        ctx.renderPath = render_path + os.path.sep
        ctx.renderAnim()

        render_result_path = os.path.join(render_path, '0001.png')
        os.rename(render_result_path, self.args['render_path'])


class Arguments(dict):

    def parse_argv(self):
        args = sys.argv[sys.argv.index('--') + 1:]
        for arg in args:
            key, value = arg.split(':', 1)
            self[key] = value


script = BlenderScript()
script.render()
