# Copyright (C) 2007-2008 www.stani.be
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/

"""For write access -> export to dict -> make diff ->
update with pyexiv2"""

try:
    _
except NameError:
    _ = unicode

import cStringIO
import os
import re
import sys
import zlib

if __name__ == '__main__':
    sys.path.extend(['..','../..'])
    __builtins__._=str

import wx
import wx.grid as  gridlib

from lib import system
from lib.formField import IMAGE_READ_EXTENSIONS
from lib.unicoding import ENCODING

from lib.pyWx import droplet
from lib.pyWx import inspectorTag
from lib.pyWx.wildcard import wildcard_list
from lib.pyWx.clipboard import copy_text
from lib.pyWx.wxPil import pil_wxBitmap

#TODO: refactor to drop these dependencies
from core.pil import extract_info, extract_info_geometry, pyexiv2, DOT,\
    open_image, exif_transpose

COL_METADATA_TAG    = 1
COL_METADATA_VALUE  = 2
COL_ALL_INDEX       = 3
COL_TAG_INDEX       = 4

CONFIRM_DELETE_TAG  = _('Are you sure you want to delete this tag?')
SIZE        = (470,510)
SELECT      = _('Select')
ALL         = _('All')
RE_TAG      = re.compile('^<(Exif|Iptc)[.].+>$')
RE_TAG_ERROR= _('''\
The tag "%s" is not valid.
It should follow the syntax: <Exif.*> or <Iptc.*>\
''')
#FILENAME = '/home/stani/sync/Afbeeldingen/20070118-verhuis/IMG_1077.JPG'
FILENAME = ''

TAGS        = [SELECT, ALL,'Pil']
if pyexiv2:
    TAGS.extend(['Exif','Iptc'])
TAGS.extend(['EXIF','Pexif','Zexif'])
WX_ENCODING = wx.GetDefaultPyEncoding()

def shortcut(key):
    return ''

def show_error(message,title=_('Image Inspector Error'),parent=None,
        style=wx.OK | wx.ICON_ERROR):
    if parent is None:
        parent = wx.GetApp().GetTopWindow()
    dlg = wx.MessageDialog(parent, 
            message,
            title,
            style,
    )
    answer  = dlg.ShowModal()
    dlg.Destroy()
    return answer
    
def ask(message):
    return show_error(message,style=wx.YES_NO|wx.ICON_QUESTION)

def extract_data(filename,info,thumb_size=(128,128)):
    if filename.strip():
        #open image
        image = open_image(filename)
        extract_info(info,image,filename,metadata=True)
        #exif orientation
        image = exif_transpose(image)
        extract_info_geometry(info,image)
        #resize
        image.thumbnail(thumb_size)
        thumb = pil_wxBitmap(image)
    else:
        thumb = wx.EmptyBitmap(*thumb_size)
    return [[shortcut(key),'<%s>'%_(key),value]
        for key, value in info.items()], thumb
        
def getPencilData():
    # Embedded icon from the openclipart gallery
    return zlib.decompress(
'x\xda\x01\x88\x01w\xfe\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\
\x00\x00\x00\x10\x08\x06\x00\x00\x00\x1f\xf3\xffa\x00\x00\x00\x04sBIT\x08\
\x08\x08\x08|\x08d\x88\x00\x00\x01?IDAT8\x8d\x8d\xd1\xbdj\x94A\x14\x06\xe0gc\
4\x12\xe3\x8aM\xb0N\xa1M\xb0\xb3K\x04+\x03{\x0b\xa2!F\xc5\xe3\r\xe4\n\xbc\
\x84\x93?"\xa4P\xb0\xb4\xd8"\x85`k#6\x16Z$\x85\xd8l D\x8c\x04!\xf1\xb3\x99\r\
\x1f\xeb\xeefO73<\xef\x9c9\xd3\xa8\xaa\xca\xa8\x15\x11\x15\xbe\xe0\x06\xd6\
\xf0\xb21J@D\\\xc2\x1f|\xc2\x0b\x1c\xe0+\x8c\x8d\x80\'\n\xfe\x8em\xecf\xe67\
\xccb\x7fh\x07\x11q\x19\xc7\xd8\xc1;\xcc\x17x\x173x30 "&\xf1\x1bo\xf1 3O\xca\
\xfe+\xfc\xc0\x1d\xdc\x1f\x1f\x80\xaf\xe0\x08\xaf\xf1(3Ok\xc7\x1f\xcaS\xe0\
\xe2\x7f3\x88\x88\xa9\x82\xb7\xf1\xb0\x8e#\xa2\x81{ey53O\xc6zp\x13\xbf\xb0\
\x85\xa5\xcc\xfc\xdb\x83W\xb1X\xf0\x11\xb5_\x88\x88k\xf8\x89u<\xe9\x83\xd7\
\xf0\xac\x8e\xcf\x02"\xe2:\x0e\x91x\x9e\x99U\x0f^\xc7\xd3^\x0c\xdd!\x1e\xe0#\
V\xfa\xe0\r,\xf7\xc3p\xa1\xd3\xe9T\xe8`\x0f\xb3\xedv\xfb\xb4\xd5j\xed\x16\
\xbc9\x0c\xd7;\x98\xc6\x02n\x96\x9b\xdf\x17\xfcx\x18\xae\x07tk\x06s\xf8\x8c\
\xdb\xe7\xe1~\x01p\x0b\xcdQ\xf0\xa0\x80ff6\xce\x83\xdd\xfa\x07\xca\x88\x87\
\x90\xc0\xf9\xffl\x00\x00\x00\x00IEND\xaeB`\x82A.\xa9\xf2' )

def getPencilBitmap():
    return wx.BitmapFromImage(getPencilImage())

def getPencilImage():
    stream = cStringIO.StringIO(getPencilData())
    return wx.ImageFromStream(stream)


class IconRenderer(gridlib.PyGridCellRenderer):
    def __init__(self):
        """
        This draws a pencil icon if the value is editable.
        """
        gridlib.PyGridCellRenderer.__init__(self)
        self.icon  = getPencilBitmap()

    def Draw(self, grid, attr, dc, rect, row, col, isSelected):
        attr    = [grid.even_attr,grid.odd_attr][row%2]
        color   = attr.GetBackgroundColour()
        # clear the background
        dc.SetBackgroundMode(wx.SOLID)
        dc.SetBrush(wx.Brush(color, wx.SOLID))
        dc.SetPen(wx.Pen(color, 1, wx.SOLID))
        dc.DrawRectangleRect(rect)
        #create icon dc
        icon = wx.MemoryDC()
        icon.SelectObject(self.icon)
        # copy the image but only to the size of the grid cell
        width, height = self.icon.GetWidth(), self.icon.GetHeight()
        x = (rect.width-width)/2
        y = (rect.height-height)/2
        dc.Blit(rect.x+x, rect.y+y, width, height, icon, 0, 0, wx.COPY, 
            True)

class Grid(droplet.Mixin,inspectorTag.Grid):
    wildcard    = '|'.join([wildcard_list(_('Images'),
        IMAGE_READ_EXTENSIONS),_('All files'),'*'])
        
    def _init(self):
        super(Grid,self)._init()
        self.info       = {}
        self.SetDefaultEditor(gridlib.GridCellTextEditor())
        self.SetCellEditor(0,1,gridlib.GridCellTextEditor())
        self.SetAsFileDropTarget(self,self.OnDrop)
        self.SetAsFileDropTarget(self.GetEmpty(),self.OnDrop)
        self.SetAsFileDropTarget(self.GetDialog(),self.OnDrop)
        self.Bind(wx.EVT_KEY_DOWN, self.OnKeyDown)

        self.Bind(gridlib.EVT_GRID_CELL_RIGHT_CLICK, 
            self.OnGridCellRightClicked)
        
    def GetTableAttr(self,row,col,kind):
        attr = [self.even_attr,self.odd_attr][row%2].Clone()
        self.AttrIncRef(attr)
        #else:
        #    attr.SetRenderer(IconRenderer())
        #only Exif and Iptc cells should be editable
        if self.IsCellEditable(row,col):
            self.SetAttrReadOnly(attr,col==0)
            if col==0:
                attr.SetRenderer(IconRenderer())
        else:
            self.SetAttrReadOnly(attr,True)
        return attr
        
    def IsCellEditable(self,row,col):
        return pyexiv2 and self.IsTagCell(row,col)
        
    def IsTagCell(self,row,col):
        if len(self.data)>row and self.info:
            tag =  self.GetRowMetadataTag(row)
            if tag in self.info['exif']+self.info['iptc']:
                return True
        return False
        
    def GetRowMetadataTag(self,row):
        return str(self.data[row][COL_METADATA_TAG][1:-1])
       
    def GetRowMetadataValue(self,row):
        return self.data[row][COL_METADATA_VALUE]
        
    def DeleteTableRows(self, pos=0, numRows=1):
        row_data = self.data[pos]
        del self.all_data[row_data[COL_ALL_INDEX]]
        del self.tag_data[row_data[COL_TAG_INDEX]]
        del self.data[pos]
        self.RefreshAll()
        
    def SetTableValue(self,row,col,value):
        if self.data[row][col]==value:
            return
        if col == COL_METADATA_VALUE:
            #new value -> edit current
            metadata_tag    = self.GetRowMetadataTag(row)
            metadata_value  = unicode(value)
            changes = [(metadata_tag,metadata_value)]
        elif col == COL_METADATA_TAG:
            #new tag -> replace new & delete current
            if not RE_TAG.match(value):
                show_error(RE_TAG_ERROR%value)
                return
            metadata_tag        = value[1:-1]
            metadata_tag_old    = self.GetRowMetadataTag(row)
            metadata_value      = self.GetRowMetadataValue(row)
            changes = [(metadata_tag,metadata_value),
                (metadata_tag_old,None)]
        else:
            #should never happen (see GetTableAttr)
            raise Exception('Wrong column.')
        if self.SaveChanges(changes,
            _('Unable to save tag <%s>')):
            #succesfull
            if value.strip():
                row_data        = self.data[row]
                row_data[col]   = \
                self.tag_data[row_data[COL_TAG_INDEX]][col] = \
                self.all_data[row_data[COL_ALL_INDEX]][col] = value
            else:
                self.DeleteRows(row)

    def SaveChanges(self,changes, error_message):
        try:
            image               = pyexiv2.Image(self.filename)
            image.readMetadata()
            for metadata_tag,metadata_value in changes:
                if metadata_value is None:
                    del image[metadata_tag]
                else:
                    image[metadata_tag] = metadata_value
            image.writeMetadata()
            return True
        except Exception, error:
            show_error('%s:\n%s'%(error_message%metadata_tag,
                unicode(error)))
            return False

    def UpdateValues(self):
        """Update all displayed values"""
        # This sends an event to the grid table to update all of the values
        msg = gridlib.GridTableMessage(self.table, 
            gridlib.GRIDTABLE_REQUEST_VIEW_GET_VALUES)
        self.ProcessTableMessage(msg)
        
    def OnGridCellRightClicked(self, event):
        """(row, evt) -> display a popup menu when a row label is right clicked"""
        # Did we click on a row or a column?
        event.Skip()
        row, col        = event.GetRow(), event.GetCol()
        metadata_tag    = self.GetRowMetadataTag(row)

        what = (_('Tag'),_('Value'))[col-COL_METADATA_TAG]
        menu = wx.Menu()
        menu.Append(wx.ID_COPY, _('Copy %s')%what)
        if self.IsCellEditable(row,col):
            menu.Append(wx.ID_DELETE, _("Delete Tag"))

        def on_copy(event):
            self.OnCopy(position=(row,col))
            
        def on_delete(event):
            changes         = [(metadata_tag,None)]
            if ask('%s\n<%s>'%(CONFIRM_DELETE_TAG,metadata_tag)) \
                    == wx.ID_YES \
                and self.SaveChanges(changes,
                    _('Unable to delete tag <%s>')):
                self.DeleteRows(row)
                
        self.Bind(wx.EVT_MENU, on_copy, id=wx.ID_COPY)
        self.Bind(wx.EVT_MENU, on_delete, id=wx.ID_DELETE)
        self.PopupMenu(menu)
        menu.Destroy()

    def OnKeyDown(self,event):
        if event.ControlDown() and event.GetKeyCode() == 67:
            self.OnCopy()
        else:
            event.Skip()
            
    def show_message(self,message,title='',
            style=wx.OK | wx.ICON_EXCLAMATION):
        dlg = wx.MessageDialog(self, 
                message,
                title,
                style,
        )
        answer  = dlg.ShowModal()
        dlg.Destroy()
        return answer
        
    def OnDrop(self,filenames,x,y):
        f   = filenames[0]
        if system.is_file(f):
            self.OpenImage(f)
            return
        if type(f) is unicode:
            for encoding in [WX_ENCODING,'latin1','utf-8',ENCODING]:
                try:
                    f   = f.encode(encoding)
                    if system.is_file(f):
                        self.OpenImage(f)
                        return
                except UnicodeEncodeError:
                    pass
        self.show_message(_('Only an image file is allowed.'))
        
    def SetTag(self,tag):
        """Filters from all_data to tag_data"""
        super(Grid,self).SetTag(tag)
        self.SetTagData(tag)
        self.SetFilter()
        
    def SetTagData(self,tag):
        if tag == ALL:
            self.tag_data    = [row+[index] 
                for index, row in enumerate(self.all_data)]
        elif tag == SELECT:
            self.tag_data    = [row+[index] 
                for index, row in enumerate(self.all_data)
                if not(DOT in row[COL_METADATA_TAG])]
        else:
            tag             = '<'+tag+DOT
            n               = len(tag)
            self.tag_data   = [row+[index] 
                for index, row in enumerate(self.all_data)
                if row[COL_METADATA_TAG][:n]==tag]

    def SetFilter(self,filter=None):
        if filter is None:
            filter  = self.GetFilter().GetValue()
        if filter.strip():
            self.data = []
            for index, row in enumerate(self.tag_data):
                try:
                    if filter.lower() in unicode(row).lower():
                        self.data.append(row+[index])
                except TypeError:
                    pass
                except UnicodeDecodeError:
                    pass
                
            #self.data   = [row for row in self.tag_data
            #    if filter.lower() in unicode(row).lower()]
        else:
            self.data   = [row+[index] 
                for index, row in enumerate(self.tag_data)]
        self.data.sort()
        if not self.CheckEmpty():
            self.RefreshAll()
        
    def OpenImage(self,filename):
        try:
            data, self.bmp  = extract_data(filename,self.info)
        except IOError, message:
            show_error(_('Sorry, %s.')%str(message),
                title   = _('Image Inspector'),
                parent  = wx.GetTopLevelParent(self))
            return
        self.filename   = filename
        self.SetData(data,SELECT)
        
    def OnCopy(self,event=None,position=None):
        if self.data:
            if position:
                row, col    = position
            else:
                row     = self.GetGridCursorRow()
                col     = self.GetGridCursorCol()
            copy_text(unicode(self.data[row][col]))
            
    def GetCellRowCol(self,event=None):
        if event:
            x, y = event.GetPosition()
            return self.XToCol(x), self.YToRow(y)
        else:
            return self.GetGridCursorRow(), self.GetGridCursorCol()

        
class SingleGrid(Grid):
    def OnOpen(self,event):
        style   = wx.OPEN | wx.CHANGE_DIR
        if hasattr(wx,'FD_PREVIEW'):
            style   |= wx.FD_PREVIEW
        dlg = wx.FileDialog(self, _("Choose an image"),
            defaultDir      = os.path.dirname(self.filename),
            wildcard        = self.wildcard,
            style           = style,
            )
        if dlg.ShowModal() == wx.ID_OK:
            self.OpenImage(dlg.GetPath())
        dlg.Destroy()
        
    def OnOpenUrl(self,event):
        dlg = wx.TextEntryDialog(self, _("Enter an image url"))
        if dlg.ShowModal() == wx.ID_OK:
            self.OpenImage(dlg.GetValue())
        dlg.Destroy()
        
    def OpenImage(self,filename):
        super(SingleGrid,self).OpenImage(filename)
        self.GetDialog()._OpenImage(filename)

    def SetFilter(self,filter=None):
        super(SingleGrid,self).SetFilter(filter)
        dlg = self.GetDialog().EnableImage(bool(self.data))
            
    def GetDialog(self):
        return wx.GetTopLevelParent(self)

class Browser(inspectorTag.Browser):
    ContentCtrl         = Grid
    
    def _init(self):
        self.GetContent().SetTag(SELECT)
        
    def GetPaintMessage(self):
        content     = self.GetContent()
        if not content.info:
            return _('drag & drop any image here')
        if content.tag_data:
            return _('broaden your search')
        tag = self.tag.GetStringSelection().lower()
        if tag == 'Exif' and not pyexiv2:
            return _('please install pyexiv2')
        return _('no %s tags found')%tag
    
class SingleBrowser(Browser):
    ContentCtrl     = SingleGrid
    
class SingleFrame(inspectorTag.Frame):
    Browser     = SingleBrowser
    def __init__(self,parent,filename=FILENAME,*args,**keyw):
        super(SingleFrame,self).__init__(parent,[],TAGS, *args,**keyw)
        if not os.path.isfile(filename):filename = ''
        self.GetGrid().OpenImage(filename)
        self.filename   = '' #forces refresh of thumb
        
    def _OpenImage(self,filename):
        """To be called from the grid."""
        if filename.strip():
            di, ba      = os.path.split(filename)
            self.SetTitle('%s %s'%(ba,di))
        else:
            self.SetTitle(_('Image Inspector'))
        if self.thumb.IsShown():
            self.UpdateThumb()
            
    def _thumb(self):
        self.thumb_height   = 128
        size                = (self.thumb_height,self.thumb_height)
        bmp                 = wx.ArtProvider_GetBitmap(
            wx.ART_MISSING_IMAGE,wx.ART_OTHER,size=size)
        self.thumb      = wx.StaticBitmap(self.panel,-1,bmp,size=size)
        self.thumb.Hide()
        grid                = self.GetGrid()
        grid.SetAsFileDropTarget(self.thumb,grid.OnDrop)

        
    def _layout_top(self,main_sizer):
        self._thumb()
        main_sizer.Add(self.thumb, 0, wx.LEFT|wx.TOP, 8)
        
    def _layout_buttons(self,btn_sizer):
        self.preview    = wx.CheckBox(self.panel, -1, _("&Preview"))
        self.preview.Disable()
        self.open       = self.CreateBitmapButton(wx.ART_FILE_OPEN,
            _("Open image file"))
        self.open_url   = self.CreateBitmapButton(wx.ART_GO_HOME,
            _("Open image url"))
        self.copy   = self.CreateBitmapButton(wx.ART_COPY,
            _("Copy cell text"))
        self.copy.Disable()
        btn_sizer.Add(self.preview,0,wx.ALL|wx.ALIGN_CENTER_VERTICAL,4)
        btn_sizer.Add(self.open,0,wx.ALL|wx.ALIGN_CENTER_VERTICAL,4)
        btn_sizer.Add(self.open_url,0,wx.ALL|wx.ALIGN_CENTER_VERTICAL,4)
        btn_sizer.Add(self.copy,0,wx.ALL|wx.ALIGN_CENTER_VERTICAL,4)
        super(SingleFrame,self)._layout_buttons(btn_sizer)
        
    def _events(self):
        super(SingleFrame,self)._events()
        grid    = self.GetGrid()
        self.open.Bind(wx.EVT_BUTTON,grid.OnOpen)
        self.open_url.Bind(wx.EVT_BUTTON,grid.OnOpenUrl)
        self.copy.Bind(wx.EVT_BUTTON,grid.OnCopy)
        self.preview.Bind(wx.EVT_CHECKBOX,self.OnPreview)
        
    def OnPreview(self,event):
        state   = event.IsChecked()
        if state: self.UpdateThumb()
        self.thumb.Show(state)
        self.panel.Layout()
        
    def UpdateThumb(self):
        grid    = self.GetGrid()
        if self.filename != grid.filename:
            self.filename = grid.filename
            wx.BeginBusyCursor()
            bmp     = self.GetGrid().bmp
            self.thumb.SetBitmap(bmp)
            size    = (bmp.GetWidth(),bmp.GetHeight())
            self.thumb.SetSize(size)
            self.thumb.SetMinSize(size)
            self.Layout()
            wx.EndBusyCursor()
        
    def EnableImage(self,state):
        if not hasattr(self,'copy'): return
        for ctrl in [self.copy,self.preview]:
            ctrl.Enable(state)
    
if __name__ == '__main__':
    app = wx.PySimpleApp()
    frame = SingleFrame(None,FILENAME,size=SIZE)
    frame.Show(True)
    app.MainLoop()
